<template>
  <div>
    <!--Cabecera-->
    <section class="hero is-small is-link">
      <div class="hero-body">
        <p class="title">
          Catálogo
        </p>
        <p class="subtitle">
          Aquí se muestra la lista de productos disponibles actualmente
        </p>
      </div>
    </section>

    <!--Búscador y filtros-->
    <div class="search-area">
      <nav class="level">
        <!-- Left side -->
        <div class="level-left">
          <div class="level-item">
            <div class="field has-addons">
              <p class="control is-expanded">
                <input class="input" type="text" placeholder="búsqueda de productos..." style="min-width: calc(45vw)">
              </p>
              <p class="control">
                <button class="button is-link">
                  <!--font-awesome-icon icon="search"/-->
                  <font-awesome-icon icon="fa-pencil-square-o"/>
                  <!--i class="fa-pencil-square-o" aria-hidden="true"></i-->
                  Prueba
                </button>
              </p>
            </div>
          </div>
        </div>

        <!-- Right side -->
        <div class="level-right">
          <div class="level-item">
            <p class="subtitle is-5">
              <strong>Filtrar por</strong> Categoría
            </p>
          </div>
          <div class="select is-link">
            <select>
              <option v-for="(categoria, index) in categoriaList" :key="index">{{ categoria.descripcion }}</option>
            </select>
          </div>
        </div>
      </nav>
    </div>

    <!--Listado de productos-->
    <div class="list-catalogo">
      <div class="columns is-multiline">
        <div class="column is-one-quarter" v-for="product in productList" :key="product.id">
          <div class="container">

            <div class="card">

              <header class="card-header">
                <p class="card-header-title">
                  {{ product.nombre }}
                </p>
                <button class="card-header-icon" aria-label="more options" data-tooltip="Mostrar detalle">
                  <span class="icon">
                    <font-awesome-icon icon="eye" aria-hidden="true"/>
                  </span>
                </button>
              </header>

              <div class="card-content">
                <div class="content">
                  <img src="../assets/images/generic-product.png" width="150" class="image-product"
                       :alt="product.nombre"/>
                  <p v-if="product.descripcion"><strong>Descripción: </strong> {{ product.descripcion }} </p>
                  <p v-if="product._estado.nombre_estado"><strong>Estado: </strong> {{ product._estado.nombre_estado }} </p>
                  <p v-if="product.precio"><strong>Precio: </strong>
                    {{ product.precio }} Gs. </p>

                </div>
              </div>

              <footer class="card-footer">
                <a href="#" class="card-footer-item">
                  <span class="icon"><font-awesome-icon icon="credit-card"/></span> Comprar
                </a>
                <a href="#" class="card-footer-item">
                  <span class="icon"><font-awesome-icon icon="heart"/></span> Favorito
                </a>
              </footer>

            </div>

          </div>
        </div>
      </div>
    </div>

    <!--Paginador-->
    <div class="pagination-area">
      <PaginationComponent :page="pagination.page" :pages="pagination.pages" @selected="(page) => searchProducts(page)"></PaginationComponent>
    </div>

    <div class="pageloader is-bottom-to-top is-link" style="opacity: 0.8" :class="{'is-active': loading}"><span class="title">Cargando productos...</span></div>

  </div>
</template>

<script>
import {HTTP} from '@/http'
import PaginationComponent from "../components/PaginationComponent";

export default {
  name: "Catalogo",
  components: { PaginationComponent },
  data() {
    return {
      loading: false,
      search: {
      },
      pagination: {
        page: 1,
        pages: 1
      },
      productList: [],
      categoriaList: []
    }
  },
  mounted() {
    this.searchProducts();
    this.getCategorias();
  },
  methods: {
    async searchProducts(page) {
      this.loading = true;
      try {
        let data = (await HTTP.post(`/search/producto`, {
          params: {
            page: page ? page : 1
          }
        })).data;
        if (data.items) {
          this.productList = data.items;
          this.pagination.page = data.page;
          this.pagination.pages = data.pages;
        } else {
          this.productList = data;
          this.pagination = {};
        }
      } catch (error) {
        //eslint-disable-next-line no-prototype-builtins
        if (!error.hasOwnProperty('response')) {
          this.notificar('error', this.title, 'Ha ocurrido un error inesperado. Error: ' + error);
        }
        if (error.response.status !== 404) {
          this.notificar('error', this.title, 'No se han podido obtener la lista de proyectos. Error: ' + error);
        }
        this.productList = [];
      } finally {
        this.loading = false;
      }
    },
    async getCategorias() {
      try {
        let data = (await HTTP.get(`/categoria`)).data;
        if (data.items) {
          this.categoriaList = data.items;
        } else {
          this.categoriaList = data;
        }
        // Se agrega al principio la opción 'Todos'
        this.categoriaList = [{descripcion: 'Todos'}, ...this.categoriaList];
      } catch (error) {
        this.categoriaList = [];
      }
    }
  }
}
</script>

<style scoped>
.list-catalogo {
  margin: 50px;
}

.image-product {
  display: block;
  margin-left: auto;
  margin-right: auto;
  margin-bottom: 10px;
  width: 50%;
}

.search-area {
  margin-top: 20px;
  margin-left: 50px;
  margin-right: 50px;
}

.pagination-area{
  margin: 3%;
}
</style>
